//+------------------------------------------------------------------+
//|                                               DoublecciWoody.mq4 |
//|
//+------------------------------------------------------------------+
#property copyright " DoublecciWoody."
#property link      "DoublecciWoody"

#property indicator_separate_window
#property indicator_minimum -250
#property indicator_maximum 250
#property indicator_buffers 7
#property indicator_color1 Lime   //Green
#property indicator_color2 Red   //SaddleBrown
#property indicator_color3 DarkGray
#property indicator_color4 Gold
#property indicator_color5 DarkKhaki //White
#property indicator_color6 Yellow  //Magenta
#property indicator_color7 DarkKhaki  //Gold  <<<<<<<<<<<<<<<<<<<<<<<<<<
#property indicator_level1 200
#property indicator_level2 100
#property indicator_level3 0
#property indicator_level4 -100
#property indicator_level5 -200
#property indicator_level6 -50
#property indicator_level7 50
#property indicator_levelcolor White

//---- input parameters
extern int TrendCCI_Period = 170;//14
extern int EntryCCI_Period = 34;//6
extern int Trend_period = 2;//6
extern int  CountBars=1444; 
extern int  RSIperiod=8;
extern int  RSIupperlevel=55;
extern int  RSIlowerlevel=45;
extern bool Zero_Cross_Alert=False;

extern int   LineSize1=3;
extern int   LineSize2=4;
extern int   LineSize3=2;//1


double TrendCCI[];
double EntryCCI[];
double RSICheck[];
double CCITrendUp[];
double CCITrendDown[];
double CCINoTrend[];
double CCITimeBar[];
double ZeroLine[];

int trendUp, trendDown;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {
//---- indicators
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID,LineSize1);
   SetIndexBuffer(4, TrendCCI);
   SetIndexLabel(4, "TrendCCI");
   SetIndexStyle(0, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(0, CCITrendUp);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(1, CCITrendDown);
   SetIndexStyle(2, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(2, CCINoTrend);
   SetIndexStyle(3, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(3, CCITimeBar);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID,LineSize2);// 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<
   SetIndexBuffer(5, EntryCCI);
   SetIndexLabel(5, "EntryCCI");
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID,LineSize3);
   SetIndexBuffer(6, ZeroLine);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   int limit, i, trendCCI, entryCCI;
   int counted_bars = IndicatorCounted();
   static datetime prevtime = 0;
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;

   limit=Bars;//-counted_bars;
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
     SetIndexDrawBegin(6,Bars-CountBars);
   

      trendCCI = TrendCCI_Period;
      entryCCI = EntryCCI_Period;
 
   
      IndicatorShortName("(TrendCCI: " + trendCCI + ", EntryCCI: " + entryCCI + ") ");   
      
      
 
      
      
      
   for(i = limit; i >= 0; i--) {
      CCINoTrend[i] = 0;
      CCITrendDown[i] = 0;
      CCITimeBar[i] = 0;
      CCITrendUp[i] = 0;
      ZeroLine[i] = 0;
      TrendCCI[i] = iCCI(NULL, 0, trendCCI, PRICE_TYPICAL, i);
      EntryCCI[i] = iCCI(NULL, 0, entryCCI, PRICE_TYPICAL, i);
     
      
      if(TrendCCI[i] > 0 && TrendCCI[i+1] < 0) {
         if (trendDown >  Trend_period) trendUp = 0;
      }
      if (TrendCCI[i] > 0) {
         if (trendUp <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp >  Trend_period) {
            CCITrendUp[i] = TrendCCI[i];
         }
      }
      if(TrendCCI[i] < 0 && TrendCCI[i+1] > 0) {
         if (trendUp >  Trend_period) trendDown = 0;
      }
      if (TrendCCI[i] < 0) {
         
         if (trendDown <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown >  Trend_period) {
            CCITrendDown[i] = TrendCCI[i];
         }
      }
   }
   
   if (Zero_Cross_Alert == true) {
      if (prevtime == Time[0]) {
         return(0);
      }
      else {
         if(TrendCCI[0] < 0) {
            if((EntryCCI[0] < 0) && (EntryCCI[1] >= 0) && (iRSI(NULL,0,RSIperiod, PRICE_CLOSE,0)<RSIlowerlevel)) {
               Alert(Symbol(), " M", Period(), " Enter Short Trade Now     RSI: ",iRSI(NULL,0,RSIperiod, PRICE_CLOSE,0),"   TrendCCI: ",TrendCCI[0],"   EntryCCI: ",EntryCCI[0]);
             PlaySound("alert2.wav");
           }
         }
         else if(TrendCCI[0] > 0) {
            if((EntryCCI[0] > 0) && (EntryCCI[1] <= 0) && (iRSI(NULL,0,RSIperiod, PRICE_CLOSE,0)>RSIupperlevel)) {
               Alert(Symbol(), " M", Period(), " Enter Long Trade Now     RSI: ",iRSI(NULL,0,RSIperiod, PRICE_CLOSE,0),"   TrendCCI: ",TrendCCI[0],"   EntryCCI: ",EntryCCI[0]);
               PlaySound("alert2.wav");
            }
         }
         prevtime = Time[0];
      }
   }
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+